      subroutine coefts(w,entor)
      include 'SPRINC'
      real rmaj(nchi*npsi),zed(nchi*npsi),hpsi(nchi*npsi),
     %     hchi(nchi*npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi),
     %     awi(ionmax),qi(ionmax),densi(ionmax),tempi(ionmax)
      complex acoef(nchi*npsi),bcoef(nchi*npsi),
     %        ccoef(nchi*npsi),dcoef(nchi*npsi),
     %        ecoef(nchi*npsi),fcoef(nchi*npsi),gcoef(nchi*npsi),
     %        cwork1(nchi*npsi),cwork2(nchi*npsi),
     %        cwork3(nchi*npsi),cwork4(nchi*npsi),
     %        tplus0(ionmax+1),tplus1(ionmax+1),
     %        tmins0(ionmax+1),tmins1(ionmax+1),alpha(ionmax+1),
     %        ckrt(4),cnprp2,tprpwk,tcrswk,alpawk,dwnwrk,
     %        ctemp,dtemp,chitmp,psitmp
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
     %       /soef/ ecoef,fcoef,gcoef
c
      data dwnzip /1.e-5/
c
c     COEFTS fills the /coef/ block, which contains the plasma dependent
c     coefficients for the differential wave equation, and the /soef/
c     block which contains extra coefficients for finding the electric
c     fields from the solution vector.
c
      ntot=nchi*npsi
      norigl=nchi
      nbodyf=nchi+1
c
      ako2=1.11265e-17*w**2
c
      do 10 i=1,ntot
      akzt=entor/rmaj(i)
      anzt2=akzt**2/ako2
      jpsi=1+(i-1)/nchi
      ichi=i-(jpsi-1)*nchi
c
c calculate the range of R covered by this grid point to make sure
c that we pick up the Z-function resonance in sptensor.
c (The same algorithm must be used in subroutines ZDILE and COEFTS):
c
      zdR=0.0
      if(ichi .ne. 1 .and. ichi .ne. nchi)
     %                               zdR=abs(Rmaj(i+1)-Rmaj(i-1))
      if(i .eq. nchi) zdR=abs(Rmaj(i-nchi+1)-Rmaj(i-1))
      if (jpsi .eq. 1) then
           zdR=max(zdR,abs(Rmaj(i+nchi)-Rmaj(i)))
      else if (jpsi .eq. npsi) then
           zdR=max(zdR,abs(Rmaj(i)-Rmaj(i-nchi)))
      else
           zdR=max(zdR,abs(Rmaj(i+nchi)-Rmaj(i-nchi)))
      endif
      zdRovR=zdR/4./Rmaj(i)
c
      call plasma(bmag,dense,tempe,nions,awi,qi,densi,tempi,ichi,jpsi)
c
      call sptensor(tplus0,tplus1,tmins0,tmins1,alpha,alfven,
     %        w,zdRovR,bmag,dense,tempe,nions,awi,qi,densi,tempi,akzt)
c
      call root(ckrt,
     %          w,akzt,nions,tplus0,tplus1,tmins0,tmins1,alpha,alfven)
c
c      cnprp2=ckrt(1)**2/cmplx(ako2,0.)
c GWH: ROOT modified to give kx**2 rather than kx:
      cnprp2=ckrt(1)/cmplx(ako2,0.)
 
      tprpwk=(1.,0.)-cmplx(anzt2,0.)
      tcrswk=(0.,0.)
      alpawk=(0.,0.)
      nspec=nions+1
      do 15 isp=1,nspec
      tprpwk=tprpwk+tplus0(isp)+tmins0(isp)
     %               +cnprp2*(tplus1(isp)+tmins1(isp)-alpha(isp))
      tcrswk=tcrswk+tplus0(isp)-tmins0(isp)
     %               +cnprp2*(tplus1(isp)-tmins1(isp))
   15 alpawk=alpawk+alpha(isp)
      tprpwk=tprpwk/((1.,0.)-alpawk)
      tcrswk=tcrswk/((1.,0.)-alpawk)
      dwnwrk=tprpwk**2-tcrswk**2
c     ... check to see that denominator isn't exactly zero ...
      tval=1.+real(tprpwk)**2+aimag(tprpwk)**2+
     %        real(tcrswk)**2+aimag(tcrswk)**2
      dwnval=cabs(dwnwrk)
      if (dwnval.lt.dwnzip*tval) then
         write(6,*) 'i,rmaj(i),zed(i), dwnwrk,tprpwk,tcrswk = ',
     %        i,rmaj(i),zed(i), dwnwrk,tprpwk,tcrswk
      if (dwnval.eq.0.) then
      dwnwrk=cmplx(dwnzip*tval,0.)
      else
      dwnwrk=dwnwrk*cmplx(dwnzip*tval/dwnval,0.)
      endif
      endif
      dwnwrk=(1.,0.)/dwnwrk
c     ... temporary values for c and dcoef ...
      ccoef(i)=tprpwk*cmplx(rmaj(i),0.)
      dcoef(i)=(0.,-1.)*tcrswk*cmplx(rmaj(i),0.)
c     ... actual values for a,b, and gcoef ...
      acoef(i)=tprpwk*dwnwrk
      bcoef(i)=(0.,-1.)*tcrswk*dwnwrk
   10 gcoef(i)=dwnwrk
c
      call dpsi(ccoef,cwork1)
      call SPRFIL(cwork1,2)
      call dchi(ccoef,cwork2)
      call dpsi(dcoef,cwork3)
      call SPRFIL(cwork3,2)
      call dchi(dcoef,cwork4)
c
      do 20 i=1,ntot
      chitmp=cmplx(hchi(i),0.)
      psitmp=cmplx(hpsi(i),0.)
      ctemp=ccoef(i)
      dtemp=dcoef(i)
c Original:
c      dwnwrk=(1.,0.)/(ctemp**2+dtemp**2)**2
c GWH 19-Oct-1993 patch:
	dwnwrk = gcoef(i)**2/rmaj(i)**2
c
c GWH: ctemp and dtemp are complex, and at a cuttoff (kperp**2=0) they
c differ only by a factor of i so that dwnwrk = infinity and we get an
c overflow error.  This problem also occurred in the previous DO loop,
c where Dave had a patch if the denominator got too small.  This
c patch was stored in gcoef, which we can use here by noting that
c dwnwrk in this loop can be written in terms of the gcoef calculated
c in the previous loop as:
c
c	dwnwrk = gcoef(i)**2/rmaj(i)**2
c
c Dave Smithe discusses this problem in more detail in
c "Annual Performance Report for DoE Grant DE-FG05-91ER54129", 
c MRC/WDC-R-277, written around Feb. 15, 1992, point # 14 on p.5 of
c Appendix C.  There he points out an alternative way to solve for the
c fields at the cuttoff (nperp**2 = 0).  He seems to implement this
c in the fields.f subroutine, but I don't know why he didn't consider
c the related problem below. Perhaps dwnwrk scales out of the problem
c if it is too big?
c
c I talked to Dave Smithe by phone on 13-Oct-1993, and this patch I
c have put in seems reasonable to him (though he hasn't thought
c about this code for 1-2 years...).  However, he was surprised that
c the results do depend somewhat on the exact value of dwnzip, rather
c than becoming completely insensitive to dwnzip for small values of
c dwnzip.  The reason is that the final ccoef and dcoef calculated
c below do not have a simple scaling to gcoef.  For example,
c
c 	ccoef = ccoef + cwork3
c 		\propto gcoef**2 c1 + gcoef c2
c
c i.e., changing the scale of gcoef (gcoef' = alpha*gcoef) cannot
c be corrected elsewhere by scaling ccoef in a simple way.  Although
c presumably the first term will dominate for very large gcoef...
c
c It seems to me that the really best way to fix this problem is to
c alter slightly the dielectric tensor coefficients output by SPTENSOR
c so that one is never exactly at a cuttof nperp**2=0, i.e., by
c adding a small amount of dissipation to all of the species...
c What might be slightly easier, though less rigorous, would be
c to modify tprpwk and tcrswk in the previous loop (and in root) 
c so that they
c are never exactly equal (tprpwk=tcrswk+epsilon), thus affecting
c all derived quantities in the same way, not just gcoef and dwnwrk...
c

      ccoef(i)=dwnwrk*(
     %      (dtemp**2-ctemp**2)*(chitmp*cwork1(i)+psitmp*cwork4(i))
     %     +(2.,0.)*ctemp*dtemp*(psitmp*cwork2(i)-chitmp*cwork3(i)))
      dcoef(i)=dwnwrk*(
     %      (dtemp**2-ctemp**2)*(psitmp*cwork2(i)-chitmp*cwork3(i))
     %     -(2.,0.)*ctemp*dtemp*(psitmp*cwork4(i)+chitmp*cwork1(i)))
      ecoef(i)=dwnwrk*(-ctemp*(chitmp*cwork1(i)+psitmp*cwork4(i))
     %                   +dtemp*(psitmp*cwork2(i)-chitmp*cwork3(i)))
   20 fcoef(i)=dwnwrk*( ctemp*(psitmp*cwork2(i)-chitmp*cwork3(i))
     %                   +dtemp*(psitmp*cwork4(i)+chitmp*cwork1(i)))
c
      do 30 i=1,ntot
   30 cwork1(i)=cmplx(hchi(i)/hpsi(i),0.)
      call dpsi(cwork1,cwork3)
      call SPRFIL(cwork3,2)
      do 31 i=1,ntot
   31 cwork3(i)=cwork3(i)*acoef(i)*cmplx(hpsi(i)/rmaj(i),0.)
c
      do 40 i=1,norigl
   40 cwork2(i)=pcoef(i)
      do 41 i=nbodyf,ntot
   41 cwork2(i)=cmplx(hpsi(i)/hchi(i),0.)
      call dchi(cwork2,cwork4)
      do 42 i=1,norigl
   42 cwork4(i)=cwork4(i)*acoef(i)*cmplx(hpsi(i)/(pcoef(i)*rmaj(i)),0.)
      do 43 i=nbodyf,ntot
   43 cwork4(i)=cwork4(i)*acoef(i)*cmplx(hchi(i)/rmaj(i),0.)
c
      do 50 i=1,ntot
      ccoef(i)=ccoef(i)+cwork3(i)
      dcoef(i)=dcoef(i)+cwork4(i)
      ecoef(i)=ecoef(i)+(cwork3(i)*acoef(i)
     %                  +cwork4(i)*bcoef(i))*cmplx(1./rmaj(i),0.)
   50 fcoef(i)=fcoef(i)+(cwork3(i)*bcoef(i)
     %                  -cwork4(i)*acoef(i))*cmplx(1./rmaj(i),0.)
      do 51 i=1,ntot
      ecoef(i)=ecoef(i)*cmplx(rmaj(i)**2,0.)/gcoef(i)
   51 fcoef(i)=fcoef(i)*cmplx(rmaj(i)**2,0.)/gcoef(i)
c
c     call output(1)
      return
      end
