	subroutine ctrans2(inum,zvvc,zerr)
c
C CTRANS2 performs the coordinate transformation from the vacuum vessel
C grid point (zichi,zjpsi) to the real space coordinates (R,Y),
c interpolating for non-integer zichi and zjpsi.
c
c This is called by NEQNF from FPSPRUCE.
c
	include 'FPPCOM'
	include 'SPRINC'
	include 'SPRUCOM'
	real zvvc(2)	! (ichi,jpsi) as real numbers
	real zry(2)	! (R,Y)
	integer idum
 
	zichi=zvvc(1)
	zjpsi=zvvc(2)
 
c do 2D interpolation:
 
	znchi=nchi
	zi=mod(zichi,znchi)
	if(zi .lt. 0.0) zi=zi+znchi
	if(zi .lt. 0.0) zi=0.0
	i=zi
 
	if(zjpsi .lt. 1.0) zjpsi=1.0
	if(zjpsi .ge. npsi) zjpsi=npsi
	j=zjpsi
	if(j .eq. npsi) j=npsi-1
 
	zwgti1=zi-i
	zwgtj1=zjpsi-j
	zwgti=1.0-zwgti1
	zwgtj=1.0-zwgtj1
 
c f(theta=2 pi) = f(theta=0):
	if(i .eq. 0) i=nchi
	i2=i+1
	if(i2 .eq. nchi+1)i2=1
 
	zR=(Rmajich(i,j)*zwgti+Rmajich(i2,j)*zwgti1)*zwgtj
	1   +(Rmajich(i,j+1)*zwgti+Rmajich(i2,j+1)*zwgti1)*zwgtj1
 
	zY=(Zed(i,j)*zwgti+Zed(i2,j)*zwgti1)*zwgtj
	1   +(Zed(i,j+1)*zwgti+Zed(i2,j+1)*zwgti1)*zwgtj1
 
	zRY(1)=zR*100.-findR
	zRY(2)=zY*100.-findY
	zerr=zRY(1)*zRY(1)+zRY(2)*zRY(2)
 
	return
	end
