      subroutine dpsi(hvec,result)
      include 'SPRINC'
      parameter (n2fft=2*npsi-2)
      character*1 initrg
      real rwork(2*nchi*n2fft),rworkx(nchi*n2fft),rworky(nchi*n2fft),
     %     xx(nchi,n2fft),yy(nchi,n2fft),psitrg(2*n2fft)
      complex hvec(nchi,npsi),result(nchi,npsi)
      equivalence (xx,rworkx),(yy,rworky)
      data initrg /'i'/
c save chitrg for future calls to avoid having to recompute the
c FFT trig relations:
	save initrg, psitrg
c
c     DPSI performs the pseudospectral psi-derivatives simultaneously
c     at all chi in order (N**2)logN operations (N=nfft), using
c     NAG routine C06FRF.
c
      npsip1=npsi+1
      npsim1=npsi-1
      npsim2=npsi-2
c
      do 10 j=1,npsi
      do 10 i=1,nchi
      xx(i,j)=real(hvec(i,j))
   10 yy(i,j)=aimag(hvec(i,j))
      do 15 j=npsip1,n2fft
      jpsi=2*npsi-j
      do 15 i=1,nchi
      xx(i,j)=xx(i,jpsi)
   15 yy(i,j)=yy(i,jpsi)
c
      ifail=0
      call c06fre(nchi,n2fft,rworkx,rworky,initrg,psitrg,rwork,ifail)
c
      if (initrg.eq.'i') initrg='s'
c
      do 20 i=1,nchi
      xsave1=xx(i,npsi)
      ysave1=yy(i,npsi)
      xsave2=xx(i,npsim1)
      ysave2=yy(i,npsim1)
      xx(i,npsi)=0.
      yy(i,npsi)=0.
      xx(i,npsim1)=-2.*float(npsim1)*xsave1
      yy(i,npsim1)=-2.*float(npsim1)*ysave1
      do 20 j=npsim2,1,-1
      xsave1=xsave2
      ysave1=ysave2
      xsave2=xx(i,j)
      ysave2=yy(i,j)
      xx(i,j)=xx(i,j+2)-4.*float(j)*xsave1
   20 yy(i,j)=yy(i,j+2)-4.*float(j)*ysave1
      do 25 j=npsip1,n2fft
      jpsi=2*npsi-j
      do 25 i=1,nchi
      xx(i,j)=xx(i,jpsi)
   25 yy(i,j)=yy(i,jpsi)
c
      ifail=0
      call c06fre(nchi,n2fft,rworkx,rworky,initrg,psitrg,rwork,ifail)
c
      do 30 j=1,npsi
      do 30 i=1,nchi
   30 result(i,j)=cmplx(xx(i,j),yy(i,j))
c
      return
      end
