      subroutine fdsolv(scale)
      include 'SPRINC'
      integer iprmut(nchi*(npsi-1)+1)
      real rmaj(nchi,npsi),zed(nchi,npsi),hpsi(nchi,npsi),
     %     hchi(nchi,npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi),
     %     difpsi(npsi,npsi),difchi(nchi,nchi),
     %     ddfpsi(npsi,npsi),ddfchi(nchi,nchi),
     %     fdscal(nchi*(npsi-1)+1),scale(nchi,npsi)
      complex fdmtrx(3*nchi+1,nchi*(npsi-1)+1),
     %        acoef(nchi,npsi),bcoef(nchi,npsi),
     %        ccoef(nchi,npsi),dcoef(nchi,npsi),
     %        ctemp,dpsifd,dpsicd,dpsibd
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /difmtx/ difpsi,difchi,ddfpsi,ddfchi
     %       /fdinfo/ fdmtrx,fdscal,iprmut
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
c
c     FDSOLV sets up and performs the PLU decomposition of the
c     preconditioning operator.  It is identical to that of
c     subroutine WAVEOP, except that finite differences are
c     used for the psi derivatives.  The result is a matrix
c     with "nchi" superdiagonals and "nchi" subdiagonals, with
c     inversion costs therefore propertional to npsi*nchi**3.
c     This routine also finds the row scaling factors of the
c     wave operator.
c
      nchim1=nchi-1
      npsim1=npsi-1
      nrowfd=3*nchi+1
      ncolfd=nchi*(npsim1)+1
      ntot=nchi*npsi
      nbodyl=ntot-nchi
      nwallf=ntot-nchi+1
      pi=4.*atan(1.)
      delchi=2.*pi/float(nchi)
c
c     ... origin boundary condition ...
      dpsifd=cmplx(1./(psi(2)-psi(1)),0.)
      irow=nchi+1
      jcol=1
      fdmtrx(irow,jcol)=(0.,0.)
      do 20 i=1,nchi
      irowfd=nchi+1-i
      jcolfd=i+1
      ctemp=acoef(i,1)*cmplx(delchi/(2.*pi*rmaj(i,1)*pcoef(i)),0.)
      fdmtrx(irow,jcol)=fdmtrx(irow,jcol)-ctemp*dpsifd
   20 fdmtrx(irowfd,jcolfd)=ctemp*dpsifd
c
c     ... wave operator ...
      do 30 j=2,npsim1
      dpsibd=cmplx(1./(psi(j)-psi(j-1)),0.)
      dpsicd=cmplx(2./(psi(j+1)-psi(j-1)),0.)
      dpsifd=cmplx(1./(psi(j+1)-psi(j)),0.)
      do 30 i=1,nchi
      irow=nchi+1
      jcol=i+(j-2)*nchi+1
      irowfd=irow-nchi
      jcolfd=jcol+nchi
      if (j.ne.2) then
      irowbd=irow+nchi
      jcolbd=jcol-nchi
      else
      irowbd=irow+i
      jcolbd=1
      endif
c
      do 31 jcolz=jcolbd,jcolfd
      irowz=irow+jcol-jcolz
   31 fdmtrx(irowz,jcolz)=(0.,0.)
c
      ctemp=cmplx(ako2*hpsi(i,j)*hchi(i,j)/rmaj(i,j),0.)
      fdmtrx(irow,jcol)=ctemp
c
      ctemp=acoef(i,j)*cmplx(hchi(i,j)/(hpsi(i,j)*rmaj(i,j)),0.)
      fdmtrx(irow,jcol)=fdmtrx(irow,jcol)-(2.,0.)*ctemp*dpsifd*dpsibd
      fdmtrx(irowfd,jcolfd)=ctemp*dpsifd*dpsicd
      fdmtrx(irowbd,jcolbd)=ctemp*dpsibd*dpsicd
c
      ctemp=ccoef(i,j)*cmplx(1./hpsi(i,j),0.)
      fdmtrx(irow,jcol)=fdmtrx(irow,jcol)+ctemp*(dpsibd-dpsifd)
      fdmtrx(irowfd,jcolfd)=fdmtrx(irowfd,jcolfd)
     %                                 +ctemp*(dpsifd-(.5,0.)*dpsicd)
      fdmtrx(irowbd,jcolbd)=fdmtrx(irowbd,jcolbd)
     %                                 -ctemp*(dpsibd-(.5,0.)*dpsicd)
c
      do 30 k=1,nchi
      irowps=irow+i-k
      jcolps=jcol-i+k
c
      ctemp=acoef(i,j)*cmplx(hpsi(i,j)/(hchi(i,j)*rmaj(i,j)),0.)
      fdmtrx(irowps,jcolps)=fdmtrx(irowps,jcolps)
     %                              +ctemp*cmplx(ddfchi(i,k),0.)
c
      ctemp=dcoef(i,j)*cmplx(1./hchi(i,j),0.)
   30 fdmtrx(irowps,jcolps)=fdmtrx(irowps,jcolps)
     %                              +ctemp*cmplx(difchi(i,k),0.)
c
c     ... wall boundary condition ...
      do 40 i=1,nchi
      dpsibd=cmplx(1./(psi(npsi)-psi(npsim1)),0.)
      irow=nchi+1
      jcol=i+(npsi-2)*nchi+1
      irowbd=irow+nchi
      jcolbd=jcol-nchi
c
      do 41 jcolz=jcolbd,ncolfd
      irowz=irow+jcol-jcolz
   41 fdmtrx(irowz,jcolz)=(0.,0.)
c
      ctemp=acoef(i,npsi)*
     %      cmplx(-hchi(i,npsi)/(hpsi(i,npsi)*rmaj(i,npsi)),0.)
      fdmtrx(irow,jcol)=ctemp*dpsibd
      fdmtrx(irowbd,jcolbd)=-ctemp*dpsibd
c
      do 40 k=1,nchi
      irowps=irow+i-k
      jcolps=jcol-i+k
c
      ctemp=bcoef(i,npsi)*cmplx(-1./rmaj(i,npsi),0.)
   40 fdmtrx(irowps,jcolps)=fdmtrx(irowps,jcolps)
     %                                 +ctemp*cmplx(difchi(i,k),0.)
c
c     ... scaling factors ...
      do 50 i=1,nchim1
   50 scale(i,1)=1.
      do 52 i=1,nchi
   52 scale(i,npsi)=1.
      swork=1./cabs(acoef(nchi,1))
      stot=swork
      scale(nchi,1)=swork
      do 51 j=2,npsim1
      do 51 i=1,nchi
      swork=1./cabs(acoef(i,j))
      stot=stot+swork
   51 scale(i,j)=swork
      stot=stot/float(nchi*(npsi-2)+1)
      scale(nchi,1)=1./(1.+stot/scale(nchi,1)+
     %                  hpsi(nchi,1)*sqrt(ako2*scale(nchi,1)))
      do 53 j=2,npsim1
      do 53 i=1,nchi
   53 scale(i,j)=1./(1.+stot/scale(i,j)+
     %                  hpsi(i,j)*sqrt(ako2*scale(i,j)))
c
c----------------- Factor fdmtrx into PLU form -------------------------
      tol=0.
      ifail=0
      call
     %    f01nae(ncolfd,nchi,nchi,fdmtrx,nrowfd,tol,iprmut,fdscal,ifail)
      if (iprmut(ncolfd).ne.0) write (6,610)iprmut(ncolfd)
  610 format(/' ','WARNING - Small diagonal element (#',i5,') in'/
     %        ' ',10x,'upper matrix factorisation of finite difference',
     %        ' operator.')
c
      return
      end
