      subroutine fields(hvec)
      include 'SPRINC'
      complex acoef(nchi*npsi),bcoef(nchi*npsi),
     %        ccoef(nchi*npsi),dcoef(nchi*npsi),
     %        ecoef(nchi*npsi),fcoef(nchi*npsi),gcoef(nchi*npsi),
     %        hphi(nchi*npsi),echi(nchi*npsi),epsi(nchi*npsi),
     %        cwork1(nchi*npsi),cwork2(nchi*npsi),
     %        cwork3(nchi*npsi),cwork4(nchi*npsi),
     %        hvec(nchi*npsi),eye,ctest,chitmp,psitmp,swave,spolar
      real rmaj(nchi*npsi),zed(nchi*npsi),hpsi(nchi*npsi),
     %     hchi(nchi*npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /spfldcom/ hphi,echi,epsi
     %       /coef/ acoef,bcoef,ccoef,dcoef,ako2
     %       /soef/ ecoef,fcoef,gcoef
c
c     FIELDS calculates the electric and magnetic fields from the
c     solution vector of the wave equation.
c
      data cutoff /.1/
c
      hnorm=2.65442e-3*sqrt(ako2)
      ntot=nchi*npsi
      norigl=nchi
      nbodyf=nchi+1
c
      call dpsi(hvec,cwork1)
      call SPRFIL(cwork1,2)
      call dpsi(cwork1,cwork3)
      call SPRFIL(cwork3,2)
      do 10 i=1,norigl
   10 cwork4(i)=cwork1(i)
      do 11 i=nbodyf,ntot
   11 cwork4(i)=hvec(i)
      call dchi(cwork4,cwork2)
      call dchi(cwork2,cwork4)
      do 12 i=1,ntot
      cwork1(i)=cwork1(i)*cmplx(1./hpsi(i),0.)
   12 cwork3(i)=cwork3(i)*acoef(i)*cmplx(hchi(i)/(hpsi(i)*rmaj(i)),0.)
      do 13 i=1,norigl
      cwork2(i)=cwork2(i)*cmplx(pcoef(i)/hpsi(i),0.)
   13 cwork4(i)=cwork4(i)*acoef(i)*cmplx(pcoef(i)/rmaj(i),0.)
      do 14 i=nbodyf,ntot
      cwork2(i)=cwork2(i)*cmplx(1./hchi(i),0.)
   14 cwork4(i)=cwork4(i)*acoef(i)*cmplx(hpsi(i)/(hchi(i)*rmaj(i)),0.)
c
c     Toroidal component of magnetic field
      do 20 i=1,ntot
   20 hphi(i)=cmplx(0.,-hnorm/rmaj(i))*hvec(i)
c
c     Poloidal-plane components of the electric field
c     (These formulas degenerate near cutoff, where a,b -> infinity)
      do 30 i=1,ntot
      echi(i)=(cwork1(i)*acoef(i)+cwork2(i)*bcoef(i))*
     %                                           cmplx(-1./rmaj(i),0.)
   30 epsi(i)=(cwork1(i)*bcoef(i)-cwork2(i)*acoef(i))*
     %                                           cmplx(-1./rmaj(i),0.)
c
c     Recalculate electric fields near cutoffs by using
c     wave equation and the nondegenerate polarization
      do 40 i=1,ntot
      ctest=bcoef(i)/acoef(i)
      if (cabs((1.,0.)+ctest**2).lt.cutoff) then
      eye=cmplx(0.,sign(1.,-aimag(ctest)))
      ctest=(acoef(i)+eye*bcoef(i))*(fcoef(i)+eye*ecoef(i))
      if (cabs(ctest).ne.0.) then
      swave=cwork3(i)+cwork4(i)+
     %                  hvec(i)*cmplx(ako2*hchi(i)*hpsi(i)/rmaj(i),0.)
      spolar=(cwork1(i)+eye*cwork2(i))*gcoef(i)*cmplx(-1./rmaj(i),0.)
      chitmp=((-bcoef(i)+eye*acoef(i))*swave+fcoef(i)*spolar)/ctest
      psitmp=((acoef(i)+eye*bcoef(i))*swave-ecoef(i)*spolar)/ctest
      if (real(chitmp*conjg(chitmp)+psitmp*conjg(psitmp)).lt.
     %    real(echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i)))) then
      echi(i)=chitmp
      epsi(i)=psitmp
      endif
      endif
      endif
   40 continue
c
c     Recalculate electric fields near origin by using
c     wave equation and the angle derivative.
      do 50 i=1,ntot
      jpsi=1+(i-1)/nchi
      if (psi(jpsi).lt.cutoff**2) then
      ctest=acoef(i)*ecoef(i)+bcoef(i)*fcoef(i)
      if (cabs(ctest).ne.0.) then
      swave=cwork3(i)+cwork4(i)+
     %                  hvec(i)*cmplx(ako2*hchi(i)*hpsi(i)/rmaj(i),0.)
      spolar=cwork2(i)*gcoef(i)*cmplx(1./rmaj(i),0.)
      chitmp=(acoef(i)*swave-fcoef(i)*spolar)/ctest
      psitmp=(bcoef(i)*swave+ecoef(i)*spolar)/ctest
      if (real(chitmp*conjg(chitmp)+psitmp*conjg(psitmp)).lt.
     %    real(echi(i)*conjg(echi(i))+epsi(i)*conjg(epsi(i)))) then
      echi(i)=chitmp
      epsi(i)=psitmp
      endif
      endif
      endif
   50 continue
c
      call SPRFIL(hphi,0)
      call SPRFIL(echi,0)
      call SPRFIL(epsi,0)
c
      return
      end
