	subroutine fpdepnm(f1rad,fnbsours)
c
c copies FNBSOURS (the neutral beam source on all shells in units of
c particles/sec) into FNBSOUR (the neutral beam source on this shell),
c and normalizes FNBSOUR by dividing out the phase space volumes so
c it is a source for f.
c
	include 'FPPCOM'
	include 'F1COM'
 
c--the constants jm and jp are frequently used because f is
c       symmetric in xsi in the trapped region:
c       f(jm-i)=f(jp+i) for i=0 to njTrap-1
	parameter (jm=maxxsi/2, jp=maxxsi/2+1)
 
c The appropriate normalization is found by looking at the formula
c for the flux-surface averaged density:
c
c       <n> = (sum over i) (sum over j) qjaca(j)*qjace(i)*f1(i,j)
 
c include a fudge for the lower boundary condition.  The standard
c boundary condition for beams is df/dE=0 near E=0.  But because
c of rotation, the beam source may have a relative energy of zero.
c In this case, inject the beam source at a the lowest energy grid
c point.  We won't keep track of energy quite right this way, but
c at least we will keep track of particle fuelling.
	ibotto=0
	if(LLwbnd .eq. 0)ibotto=2
	do 31 ixi=1,maxxsi
	do 31 ien=ibotto,maxen
31	fnbsour(ien,ixi)=fnbsours(ien,ixi,nshe)/qjaca(ixi)/qjace(ien)/
	1   dVolfp(nshe)*dtFPP/2.
 
	if(LLwbnd .eq. 0)then
	do 40 ixi=1,maxxsi
	fnbsour(0,ixi)=0.0
	fnbsour(1,ixi)=0.0
	do 40 ien=0,1
40	fnbsour(2,ixi)=fnbsour(2,ixi)+fnbsours(ien,ixi,nshe)/
	1   qjaca(ixi)/qjace(2)/dVolfp(nshe)*dtFPP/2.
	endif
 
C
C       ...ISOTROPIZE
C
	DO 157 ien=0,maxen
	DO 157 J=1,njTrap
	fnbsour(ien,jm+J)=(fnbsour(ien,jm+J)+fnbsour(ien,jp-J))/2.
	fnbsour(ien,jp-J)=fnbsour(ien,jm+J)
157     CONTINUE
 
	return
	end
