	subroutine fpgeoinv(zB,ztheta)
c
c Fokker-Planck geometry inverse map.
c
c find the poloidal angle ztheta which corresponds
c to a given magnetic field zB.
c
	include 'FPPCOM'
 
	external fpgbinv ! calling ZBREN with this routine will
	real zBrequ ! find the theta giving this zBrequ
	real zXi    ! on this flux surface (normalized rho/rho_lim)
	common /fpgbcom/ zxi, zBrequ
 
C DMC 22 FEB 1993  --  replacing IMSL rootfinder ZBREN with local
C  root finder ZEROIN.  ZEROIN needs machine epslon.
 
	data zzeps/0.0/
	if(zzeps.eq.0.0) zzeps=x02aje()
 
c low-beta, concentric, circular flux surface approximations:
c
c	zR=Btor*Rmaj/zB
c	zcosarg=(zR-Rmaj)/rminpro(nshe)
c	if(zcosarg .gt. 1.0) zcosarg=1.0
c	if(zcosarg .lt. -1.0) zcosarg=-1.0
c	ztheta=acos(zcosarg)
 
	ir=nshe*2-1
	if (zB .le. Bminofr(ir)) then
	    ztheta=0.0
	    return
	endif
 
	if (zB .ge. Bmaxofr(ir)) then
	    ztheta=pifpp
	    return
	endif
 
c This lacks the necessary accuracy:
c	zthstar=acos( (Bavgofr(ir)-zB)/ Bdelofr(ir) )
c	ztheta=finteq1d(zthstar,ThofBr(1,ir),0.0,delThofB(ir),
c	1   numthofB(ir))
 
c instead use zbren to find the exact zero:
 
        zBrequ=zB
	zxi=xradzc(nshe)
        zth0=0.0
        zth1=pifpp
        imaxit=200
 
	data zerrrel /5.e-5/
 
c find theta to an accuracy of +- 2.*zerrrel*max(theta,0.1):
 
	zth1=zeroin(zth0,zth1,fpgbinv,0.2*zerrrel,zzeps)
cIMSL	call zbren(fpgbinv,0.0,2.*zerrrel,zth0,zth1,imaxit)
 
	ztheta=zth1
 
	return
	end
