	SUBROUTINE FPPBLK2
 
C
C  DMC OCT 1989 -- CALLABLE VERSION OF OLD FPPBLK BLOCK DATA
C   MOTIVATED TO CONVERT BY PROBLEMS IN THE DECSTATION 3100 COMPILER
C   WITH DATA INITIALIZATION OF FPPCOM
C
c
c Initializes some of the variables in the FPPCOM common block.
c
c Greg Hammett, 5-August-1988.
c
 
	include 'FPPCOM'
 
c mathematical and machine (computer hardware) constants:
	pifpp=abs(acos(-1.0))  ! pifpp = pi = 3.14159...
 
c machine accuracy:
	fppeps=x02aje(zdum)	!@ Vax
c@	fppeps=x02ajf(zdum)	! cray
 
c largest safe number:
	fppinf=1./x02ame(zdum)	!@ Vax
c@	fppinf=1./x02amf(zdum)	! cray
 
c********************************************************************
c
c This first set of variables all came from FPPRF.FOR originally
c
c*******************************************************************
 
C**********************************************************************
C                                                                     *
C	Define and set defaults for various calculation parameters    *
C	and flags.						      *
C                                                                     *
C**********************************************************************
 
	nfptherm=0  ! (reset in PROF to a better default.)
	lfptherm=0  ! default to old thermalization model.
C
c--CX spectra are calculated after every nSkipCX time steps, and
c	so are spaced nSkipCX*2*dtFPP apart.
CXX	data nSkipCX/1/
 
	nSkipCX=1
 
C	NPLTE CX SPECTRA VS ENERGY AT FIXED TIME WILL BE PROVIDED
CXX	DATA NPLTE/2/
 
	NPLTE=2
 
C
C	NPLTT CX SPECTRA VS TIME AT FIXED ENERGY WILL BE PROVIDED
CXX	DATA NPLTT/2/
 
	NPLTT=2
 
C
C	NPLTF F(VPREC) SPECTRA WILL BE PROVIDED
C	(THERE IS STORED SPACE FOR UP TO 40 OF THESE)
CXX	DATA NPLTF/0/
 
	NPLTF=0
 
c	plot f(e) at selected angles? f(a) at selected energies?
c	(0 = no, 1 = yes)
CXX	DATA LPlotE/0/, LPlotA/0/
 
	LPlotE=0
	LPlotA=0
 
!angles at which to plot f(e)
CXX	data NiAngls/45,35,25,16,6/
 
	NiAngls(1)=45
	NiAngls(2)=35
	NiAngls(3)=25
	NiAngls(4)=16
	NiAngls(5)= 6
 
!energies at which to plot f(a)
CXX	data effoa/45.e3, 35.e3, 25.e3, 15.e3, 5.e3/
 
	effoa(1)=45.e3
	effoa(2)=35.e3
	effoa(3)=25.e3
	effoa(4)=15.e3
	effoa(5)= 5.e3
 
c	contour plots of f?
CXX	data LPlotF/0/
 
	LPlotF=0
 
C
C	PLOT H(R)'S?, PLOT DETECTOR SENSITIVITIES?
CXX	DATA LPlotH/1/, LPloD/0/
 
	LPlotH=1
	LPloD=0
 
c	initialize fish bone and bad orbit losses to be off:
CXX	parameter (iMFishL=(maxen+2)*(maxxsi+2))
CXX	data fishl/iMFishL*1.0/
CXX	data loss/iMFishL*1/	!must be integer type on CRAY, RTM
 
	do 10 j=0,maxxsi+1
	  do 5 i=0,maxen+1
	    fishl(i,j)=1.0
	    loss(i,j)=1
 5	  continue
 10	continue
 
CXX	data nfpdepsw/0/    !use FPP's simplest beam deposition model
 
	nfpdepsw=0
 
! open the disk file where f is to be saved or read :
CXX	data lfget/.false./ ! .t. to initialize f from a disk file
CXX	data lfsave/.false./ ! .t. to save f onto a disk file
 
	lfget=.false.
	lfsave=.false.
 
CXX	data nshsta/1/ !starting shell of FPP calculation
CXX	data nshsto/0/ !stopping shell of FPP calculation
 
	nshsta=1
	nshsto=0
 
c default values of nshsta=1 and nshsto=0 will cause
c fpp to do all shells.
 
	rkpar=0.0   !default k_parallel of the ICRF wave
	llstix = .false.  ! .f. = Use best log(Lambda) formulas.
 
CXX	data lbador /.true./ ! .t. to turn on unconfined orbit losses
 
	lbador=.true.
 
!if desired, find the contribution to the CX signal from just 1 shell:
CXX	data nshcx/0/ ! 0 = find CX signal from all shells
 
	nshcx=0
 
CXX	data LTransp /.false./ !.t. if FPP is called by TRANSP
 
	LTransp=.false.
 
!Radial Transport loop control:
! MRLOOP is the # of radial diffusion time steps
! MRLOOP=0 is the default for no radial diffusion:
 
	mrloop=0
 
c********************************************************************
c
c This ends the section of variables which originally came from
c FPPRF.FOR
c
c*******************************************************************
 
c from FPSPRUCE.FOR:
 
c find kperp rho correction from the ratio of the absorptions found
c by FPP and by SHOOT on the previous time step, if it exists:
c (also allow for the user to input an initial non-zero guess for
c rkpcorr)
 
	Prfje0=0.0
	rkpcorr=1.0
 
	do 20 i=1,maxshe
	prffast(i)=0.0
 
	do 13 isp=1,mxions+2
	pichspec(i,isp)=0.0
13	continue
 
	do 15 j=1,nticrf+1
	eplus(i,j)=0.0
	crfpol(i,j)=0.0
	skperp(i,j)=0.0
15	continue
 
20	continue
 
c from MOMS.FOR:
 
CXX	data lnsrc /.false./  ! .t.=turn on source to maintain density
 
	lnsrc=.false.
 
!CX source:
CXX	data lcxsrc /.false./  ! .t.=turn on source part of CX operator
 
	lcxsrc=.false.
 
!add in source of cold particles from the radial diffusion model:
CXX	data lsdiff /.false./ ! .t.=replace particles lost by radial diffusion
 
	lsdiff=.false.
 
c from trtofp.for:
 
c concmi=nmin/ne for the fundamental minority species.
c concmi defaults to the same value as cbeam unless the "beam"
c is a 2cd harmonic majority species.  CONCMI is used
c to normalize the P/n profile in RFPROF.
CXX	data concmi/0.0/
 
	concmi=0.0
 
c from detech.for and detecv.for:
 
CXX	data nencx /0/  !# of energies at which to produce CX spectrum
			! nencx=0 will result in a reasonable default
CXX	data ldnb /.false./   ! .f. = use frantic neutral profile
			      ! .t. = read arbitrary neutral density
			      !       profile n0(R)
CXX	data latten /.true./  ! .t. = include standard signal attenuation
CXX	data lnasym /.false./ ! .t. = asymmetric version of Frantic n0(R)
 
	nencx=0
	ldnb=.false.
	latten=.true.
	lnasym=.false.
 
c from difmod.for:
 
CXX	data lradls /.false./ !.t.=turn on radial diffusion Krook model
 
	lradls=.false.
 
c from furate.for:
 
CXX	data LBBFuf /0/ ! .ne. 0 for approximate beam-beam reactions
CXX	data fufiti /1./ ! 1. = approximate Ti>0 in D-D reactions
 
	LBBFuf=0
	fufiti=1.0
 
c from several places:
 
c initialize default input and output device units:
CXX	data lsysout /6/ !default output to for006=sys$output
			 !      		  =terminal or log file
CXX	data lsysin /5/	 !default input from for005=sys$ouput
 
	lsysout=6
	lsysin=5
 
c from INGRID.FOR:
 
CXX	data LGrid/1/ ! 1 = uniform E grid, 0=accelerated E grid.
 
	LGrid=1
 
c--accelerated energy grid spacing:
c  For maxen=82, these numbers will result in Enerev(82)=2.87 MeV:
c
CXX	data demin/300./	!minimum step size (ev)
CXX	data demax/1.e6/       !maximum step size (ev)
CXX	data deove/.1/	 	!typical relative step size dE/E
CXX	data eminev/0.0/	!min energy of grid.  Below eminev
				!It is assumed that f is independent
				!of pitch angle and that an analytic
				!expression for f is known.
 
	demin=300.0
	demax=1.e6
	deove=0.1
	eminev=0.0
 
c from inputnml.for:
 
CXX	data numnbi /1/ ! default number of neutral beam injectors
 
	numnbi=1
 
c from plotfu.for:
 
CXX	data LYtypFus /2/ ! 2= log 1=linear Fusion yield plots
 
	LYtypFus=2
 
c from plotss.for:
 
c plotting controls:
CXX	data LlnFpl/0/	!=0 for old size with 10**n scale
			!=1 for new size with ln(f) scale
CXX	data fmin/25.0/	!min ln(f)
CXX	data fmax/40.0/	!max ln(f)
CXX	data emax/0.0/	!max energy (ev) (=0 for default)
CXX	data ymin/.001/	!ymin for 10**n scale plots
CXX	data ymax/1./	!ymax for 10**n scale plots
CXX	data LcxRtp/1/	!plot cx flux vs Rtan
CXX	data Rtmin/0.0/	!Rtan min
CXX	data Rtmax/132./!Rtan max
 
CXX	DATA LPrintF/0/ ! 1 = print out CX spectra
 
	LlnFpl=0
 
	fmin=25.0
	fmax=40.0
	emax=0.0
	ymin=0.001
	ymax=1.0
	LcxRtp=1
	Rtmin=0.0
	Rtmax=132.0
 
	LPrintF=0
 
!adjustable for precise overlays of plots (only if LlnFpl .eq. 1):
 
	NYminCX=100
	NYmaxCX=700
	NXminCX=500
	NXmaxCX=1000
 
CXX	data ntplot /.false./ !.t. = plot n(t) on each shell
CXX	data ttplot /.false./ !.t. = plot T(t) on each shell
CXX	data ptplot /.false./ !.t. = plots power balances vs. time
			      !      on each shell
 
	ntplot=.false.
	ttplot=.false.
	ptplot=.false.
 
CXX	data vprcmx /1.0e8/ !maximum velocity on precession speed
			    ! calculations????
 
	vprcmx=1.0e8
 
CXX	data cratio /1.0/  !compression ratio (1.0= no compression)
CXX	data rZbeam /1./   ! Z of the 'beam' species
 
	cratio=1.0
	rZbeam=1.0
 
C       ESTABLISH PROTON MASS FOR LATER PROGRAMS
CXX	DATA PMASS/1.67221E-24/
 
	PMASS=1.67221E-24
 
CXX	data XneoMult /0.0/  !arbitrary multiplier on neoclassical D
 
	XneoMult=0.0
	fpdifcon=0.0
	fpdiftra=0.0
	fpdifdw=0.0
 
CXX	data convmult /0.0/ !asymmetric drag multiplier (1=on)
CXX	data XRipMult /0.0/  !multiplier on ripple diffusion (1=on)
 
	convmult=0.0
	XRipMult=0.0
 
CXX	data bkgmax /1.0/ ! multiplier on background maxwellian density
			! to add to fast ion CX spectrum.
 
	bkgmax=1.0
 
c defaults for  general geometry parameters:
CXX	data fpshift0 /0.0/ ! Shafranov shift of magnetic axis (cm)
CXX	data fpellip /1.0/  ! ellipticity of plasma
 
	fpshift0=0.0
	fpellip=1.0
 
c dmc oct 12, 1989  moved this stmt from fpcf.for to here:
CXX	data lcxlos /.true./
 
	lcxlos=.true.
 
	do 50 i=1,maxshe
	rkpcpro(i)=1.0
	qldamp(i)=1.0
50	continue
	
	return
	end
