	program FPPtop
!
! This is the driver program for stand-alone version of FPPRF.
! Putting FPPRF into a subroutine allows us to call it from other
! programs such as TRANSP or SNAP.
 
	include 'FPPORT'
	include 'FPPCOM'
 
c check for consistency between FPPORT and FPPCOM common blocks:
        if(mifpen  .ne. maxen+1)
	1 call aborter(lsysout,'TRANSPs mifpen .ne. FPPs maxen')
 
        if(mifpxi  .ne. maxxsi)
	1 call aborter(lsysout,'TRANSPs mifpxi .ne. FPPs maxxsi')
 
        if(mifpsh  .ne. maxshe)
	1 call aborter(lsysout,'TRANSPs mifpsh .ne. FPPs maxsh')
 
! read in data needed to set up an FPPRF run:
! (The TRANSP version uses TRtoFP instead of INPUTNML and PROF)
 
c@c initialization call needed to run on the CRAY:
c@	call dropfile(0)
c read in data from the fpp data file FOR041:
	call inputnml
 
c--interpolate te,ti,ne from profiles given in data file
c	and calculate neutral density profiles.
	call prof
 
c--initialize the mapping from real space (R,Y) to flux surface
c coordinates (xi,th):
	call fpinvmap
 
c run fpprf:
	call fpprf(fpfrad,fpdep)
 
c write ufiles of CX spectra if they exist:
c skip this at non-VAX sites unless UFILE utilities are available:
	if(lcxtouf) call fpwruf		!@
 
c write f(E,xsi,r) for Rewoldt's gyrokinetic stability code:
	if(lfsavea) call fdump(fpfrad,fpdep)
 
	stop
	end
