	SUBROUTINE GNEUT(zAP,zZIM,zZEFF,zAIM,zAN00,zTEDG)
C  THIS PROGRAM WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
C  PLASMA PHYSICS LAB.  THIS ROUTINE WILL INTERFACE THE FPP PROGRAM
C  WITH THE "ANTIC" NEUTRAL CODE.
c
c******************************************************************
c
c  WARNING!!  This subroutine does not abide by the OLYMPUS
c convention that variables which begin with Z are local variables!
c This is because some of the variables in the FRANTIC common block
c in CNEUT begin with Z!  This isn't too bad since this
c subroutine is only used in the standalone version of FPP and it
c does not include the TRANSP common block TRCOM.
c
c******************************************************************
! 26-oct-1984, gwh, upgraded to calculate He neutral profiles in a
! Helium plasma.  aZmain=1 for usual hydrogen plasmas,
! aZmain=2 for Helium.
	include 'GNEUT1'
c	include 'towner$:[frantic]CNEUT.cmn'
	include 'CNEUT'
	include 'PROF1'
	include 'HE4COM'  !aZmain
C
	debug=.false.
	ibflag=.false.
 
	APLAS(1)=5.4858026E-4
	APLAS(2)=zAP
	APLAS(3)=zAIM
	ZPLAS(1)=-1.
	zplas(2)=aZmain
	ZPLAS(3)=zZIM
! main plasma ion density / electron density:
	DHY=(zZIM-zZEFF)/(zZIM-zplas(2))/zplas(2)
! impurity ion density / electron density:
	DIM=(zZEFF-zplas(2))/((zZIM-zplas(2))*zZIM)
 
!******** We must fool frantic into thinking that it is calculating
! a neutral profile for a hydrogenic species:
	zplas(2)=1
	zneutsav=azneut !save original value of azneut
	azneut=azmain   !temporarily set to azmain for thermal neutral calcs
 
! make sure arrays don't overflow:
	if(nshell .gt. cnt$3)then
	call aborter(6,'fatal error: # of shells exceeds gneut limit')
	endif
 
	DO 100 I=1,NSHELL
	ZONEC(I)=(I-.5)*RMIN/NSHELL
	DEN(I,1)=DENPRO(I)*1.E13
	TEMP(I,1)=TEPRO(I)*1.E-3
	DEN(I,2)=DHY*DENPRO(I)*1.E13
	TEMP(I,2)=TIPRO(I)*1.E-3
	DEN(I,3)=DIM*DENPRO(I)*1.E13
	TEMP(I,3)=TIPRO(I)*1.E-3
100     CONTINUE
	NSPEC(1)=2
	NZONES=NSHELL
	NPLAS=3
	IF(zZEFF.LT.1.001) NPLAS=2
	NNEUT=1
	TWALL(1)=zTEDG*1.E-3
	LUN6=6
!initial guess for the flux of neutrals in:
	FLUXIN(1)=5.E13
	AMINOR=RMIN
	ESFLAG=.TRUE.
	VSFLAG=.FALSE.
	MCFLAG=.TRUE.
	INFLAG=.TRUE.
	RCFLAG=.FALSE.
C  FRANTIC IS NOW CALLED WITHOUT RECOMBINATION.
	CALL NEUTS
	totsrc=FPVINT(sore)
	DO 10 I=1,NZONES
	TNUPRO(I)=TNEUT(I,1)
	NEUPRO(I)=DNEUT(I,1)+DCOLD(I,1)
10      CONTINUE
C  NOW GET THE RECOMBINATION PART.
	ESFLAG=.FALSE.
	MCFLAG=.FALSE.
	INFLAG=.FALSE.
	RCFLAG=.TRUE.
	CALL NEUTS
 
!now scale the wall neutrals (neupro) so that the wall neutrals
! plus the recombination neutrals equals zan00, the input edge
! neutral density.
! Calculates D1 and D2 which are the wall and recombination neutral
! densities extrapolated back to the wall.
 
	YN=ALOG(NEUPRO(NZONES))
	XN=ZONEC(NZONES)
	NM1=NZONES-1
	YNM1=ALOG(NEUPRO(NM1))
	XNM1=ZONEC(NM1)
	SLOPE=(YN-YNM1)/(XN-XNM1)
	B=YN-SLOPE*XN
	D1=EXP(SLOPE*RMIN+B)
	YN=ALOG(DNEUT(NZONES,1))
	YNM1=ALOG(DNEUT(NM1,1))
	SLOPE=(YN-YNM1)/(XN-XNM1)
	B=YN-SLOPE*XN
	D2=EXP(SLOPE*RMIN+B)
 
!scale wall-source neutral density up to match the boundary
! condition d1+d2=zan00:
	IF(D2.GT.zAN00)then
	write(6,1010)d2
1010    format(1x,' Warning from subroutine GNEUT:  zAN00 is less than',
	1       ' the recombination rate of ',1pe13.5)
	fac=0
	else
	FAC=(zAN00-D2)/D1
	endif
 
	DO 200 I=1,NSHELL
	TNUPRO(I)=FAC*NEUPRO(I)*TNUPRO(I)+DNEUT(I,1)*TNEUT(I,1)
	NEUPRO(I)=NEUPRO(I)*FAC+DNEUT(I,1)
	TNUPRO(I)=1000.*TNUPRO(I)/NEUPRO(I)  !convert to eV
200     CONTINUE
 
!calculate particle confinement time:
	totele=FPVINT(denpro)*1.e13
	Taup=totele/(fac*totsrc)
 
c restore value of azneut:
	azneut=zneutsav
 
	RETURN
	END
