	subroutine ingrid(xsista)
c--initialize velocity space grid
! gwh 18-oct-1984, put lots of grid points near xsista.
c
c--input:EgrMax,maxen,maxxsi (last two are parameters set in 'grid.cmn')
c--output:enerev,xsi,delten,delxsi
 
	include 'FPPCOM'
 
c************************************************************
c
c       To change a grid spacing, all you need to do is
c       change the coding in this one small section.
c
c************************************************************
c--uniform energy grid from 0.0 ev to emax ev:
	do 100 i=0,maxen
100     enerev(i)=i*EgrMax/float(maxen)
 
	if(LGrid .eq. 1)goto 175
 
cc--accelerated energy grid spacing:
cc These parameters are now given default values in fppblk2.
c For maxen=82, these parameters will give Enerev(82)=2.87 MeV.
c	data demin/300./	!minimum step size (ev)
c	data demax/1.e6/       !maximum step size (ev)
c	data deove/.1/	 !typical step size over Energy
c	data eminev/0.0/	!min energy of grid.  Below eminev
c				!It is assumed that f is independent
c				!of pitch angle and that an analytic
c				!expression for f is known.
 
	enerev(0)=eminev
	do 125 i=1,maxen
	de=deove*enerev(i-1)
	if(de .lt. demin)de=demin
	if(de .gt. demax)de=demax
125     enerev(i)=enerev(i-1)+de
 
c--now do pitch angle (vpar/v) grid from -1.0 to 1.0:
175     if(float(maxxsi/2) .ne. float(maxxsi)/2.0)then
	call aborter(lsysout,
	1   'error in ingrid: maxxsi in grid.cmn not even.')
	endif
 
!uniform pitch angle grid:
200     do 220 j=1,maxxsi
220     xsi(j)=-1. + (j-1)*2/float(maxxsi-1)
 
!non-uniform xsi grid with grid points packed near the resonant
! pitch angle xsista, using the formulas:
!
! xsi(j) = -sqrt(xsista**2 + bm * (jstar-j)**zgalph)
!	       for 1 <= j <= jstar
!
! xsi(j) =-2 xsista +sqrt(xsista**2 + bp * (j-jstar)**zgalph)
!	       for jstar <= j <= maxxsi/2
!
! For j > maxxsi/2, xsi(j)=xsi(maxxsi-j) for a symmetric grid.
 
	data zgalph /0.0/
	if(zgalph .eq. 0.0)go to 280
! DEPO, DETECH, and DETECV do not work correctly if the pitch angle grid
! depends on minor radius.  The variable pitch angle grid feature is
! useful for some RF-only cases without CX detector simulation, where we
! are trying to pack lots of grid points near the strongly resonant pitch
! angle.
	const=3*xsista**2/(1-xsista**2)
	jstar=.5+(maxxsi/2+.5+const**(1./zgalph))
	1       /(1+const**(1./zgalph))
	bm=(1.-xsista**2)/(jstar-1)**zgalph
	bp=3*xsista**2/(maxxsi/2+.5-jstar)**zgalph
 
	xsi(1)=-1.
	do 180 j=2,jstar
180     xsi(j)=-sqrt(xsista**2+bm*(jstar-j)**zgalph)
	do 185 j=jstar+1,maxxsi/2
185     xsi(j)=-2*xsista+sqrt(xsista**2+bp*(j-jstar)**zgalph)
	do 190 j=maxxsi/2+1,maxxsi
190     xsi(j)=-xsi(maxxsi+1-j)
 
c************************************************************
c
c       The rest of this subroutine remains the same.
c       All the other subroutines remain unchanged as well.
c
c************************************************************
c--calculate xsi-space step size delxsi:
280     delxsi(1)=.5*(xsi(2)-xsi(1))
	do 300 j=2,maxxsi-1
300     delxsi(j)=.5*(xsi(j+1)-xsi(j-1))
	delxsi(maxxsi)=.5*(xsi(maxxsi)-xsi(maxxsi-1))
 
c--calculate energy step size delten:
	delten(0)=.5*(enerev(0) + enerev(1))
	do 400 i=1,maxen-1
400     delten(i)=.5*(enerev(i+1)-enerev(i-1))
	delten(maxen)=.5*( enerev(maxen)-enerev(maxen-1) )
 
c-c************************************************************
c
c       Although most of the code works on the arbitrary grid
c       defined by enerev(i) and xsi(j) above, PRCDIS has not yet
c       been upgraded to the non-uniform grid.
c       Consequently, we define a map from the old 50*50 grid into
c       the new grid.
c       FTFMAP performs the mapping f(i,j)=f1(miotin(i),mjotjn(j))
c       where miotin and mjotjn are calculated here.
c
c************************************************************
 
	do 500 i=1,51
	enold=(i-1)*enerev(maxen)/50
	ilast=0
	do 490 in=ilast,maxen-1
	miotin(i)=in
490     if(enold .lt. .5*(enerev(in)+enerev(in+1)) )goto 500
	miotin(i)=maxen
500     continue
 
	do 600 j=2,51
	zold=(j-1.5)/25. -1
	jlast=1
	do 590 jn=jlast,maxxsi-1
	mjotjn(j)=jn
590     if(zold .lt. .5*(xsi(jn)+xsi(jn+1)) )goto 600
	mjotjn(j)=maxxsi
600     jlast=mjotjn(j)
 
 
	return
	end
