      subroutine plasma(bmag,dense,tempe,inumions,awi,qi,densi,tempi,
     %                                                     ichi,jpsi)
c
c     PLASMA provides the plasma parameters and magnetic field on the
c     psi and chi grid points.
c
c NIONS renamed to INUMIONS to avoid name conflict with FPPCOM
c
	include 'FPPCOM'
	include 'SPRINC'
	include 'SPRUCOM'
 
	integer inumions
	real awi(ionmax)
	real qi(ionmax)
	real densi(ionmax)
	real tempi(ionmax)
 
	bmag=Btor/1.e4*rmaj/100./rmajich(ichi,jpsi)
 
	call ctrans(ichi,jpsi,zr)
 
	dense=1.e6*fpintrp(zr,drelec,rminpro,nshell)
	tempe=1.e-3*fpintrp(zr,trelec,rminpro,nshell)
 
	if(nions .gt. ionmax)then
	    call aborter(lsysout,
	1   'ICH3d can not handle this many ion species')
	else
	    inumions=nions
	endif
 
	do 40 i=1,nions
	awi(i)=nAions(i)
	qi(i)=nZions(i)
	densi(i)=1.e6*fpintrp(zr,drions(1,i),rminpro,nshell)
 
	if(i .eq. nfasti) densi(i)=
	1   densi(i)*fpintrp(zr,qldamp,rminpro,nshell)
 
c use T_perp or T_parallel, depending on whether this a 2cd harmonic
c ion species:
 
	znharm=freqrf/(1.525e7*bmag*nZions(i)/nAions(i))
 
	if(znharm .gt. 1.5 .and. znharm .lt. 2.5) then
	zttot=1.e-3*fpintrp(zr,trions(1,i),rminpro,nshell)
	ztpar=1.e-3*fpintrp(zr,trionspa(1,i),rminpro,nshell)
	tempi(i)=(3*zttot-ztpar)/2.
	else
	tempi(i)=1.e-3*fpintrp(zr,trionspa(1,i),rminpro,nshell)
	endif
 
40	continue
 
c fill in the "vacuum" density and temperature parameters:
	if (zr .gt. rmin) then
		dense=1.e6*vacden
		tempe=1.e-3*vactemp
		do 60 i=1,nions
		tempi(i)=1.e-3*vactemp
60		densi(i)=(vacden/drelec(nshell)) *densi(i)
	endif
 
	return
	end
