C
C     THIS PROGRAM PLOTS THE RESULTS FOR F AT 5 ENERGIES AS A FUNCTION
C     OF PITCH ANGLE
C
      SUBROUTINE PLOTA
C
C
C     COMMON BLOCKS
C
	include 'FPPCOM'
 
	dimension fplo(maxxsi)
	character string*80
	integer iengs(5)   !index of energies at which to plot f(a)
 
!find nearest energies for plots:
	do 400 i=1,5
	en=effoa(i)
	if(en .le. enerev(0))then
	iengs(i)=0
	go to 400
	endif
	if(en .ge. enerev(maxen))then
	iengs(i)=maxen
	go to 400
	endif
	do 425 j=1,maxen
	if(en .lt. .5*(enerev(j)+enerev(j-1)))go to 430
425	continue
	iengs(i)=maxen
	go to 400
430	iengs(i)=j-1
400	continue
 
C
C     FIND MAXIMUM DATUM TO BE PLOTTED
C
      SMAX=0.0
      DO 300 I=1,5
      DO 300 J=1,maxxsi
      IENG=IENGS(I)
      IF(SMAX.LT. f1(IENG,J) ) SMAX=f1(IENG,J)
300	CONTINUE
	if(smax .eq. 0.0)return	!no data to plot
C
C     PLOT AT 5 ENERGIES, NORMALIZED TO MAXIMUM
C
	call initt(240)
	CALL BINITT
	call fpgrlab
	call npts(maxxsi)
      DO 100 I=1,5
      IENG=IENGS(I)
      DO 200 J=1,maxxsi
      FPLO(J)=f1(IENG,J)/SMAX
  200 CONTINUE
 
c--set minimum y for plot:
	data zfamin/.001/
      IF(I.EQ.1) CALL DLIMY(zfamin,1.0)
      IF(I.EQ.1) CALL YTYPE(2)
      IF(I.EQ.1) CALL CHECK(xsi,FPLO)
      IF(I.EQ.2) CALL LINE(7474)
      IF(I.EQ.3) CALL LINE(5454)
      IF(I.EQ.4) CALL LINE(3434)
      IF(I.EQ.5) CALL LINE(1414)
      IF(I.EQ.1) CALL DSPLAY(xsi,FPLO)
      IF(I.NE.1) CALL CPLOT(xsi,FPLO)
  100 CONTINUE
      TIMM=TIME*1000.
	WRITE(TEXT1,10)
10	FORMAT('Fast ion f(Vpar/V) at several energies$')
	CALL AGTCGT(750,TEXT1)
	WRITE(TEXT1,20) TIMM,NSHE,smax
20      FORMAT('Time = ',F5.1,' MSEC','  radial shell # =',I2,
     >         '  max plotted f =',1pe10.3,'$')
	CALL AGTCGT(0,TEXT1)
	WRITE(TEXT1,30)
30	FORMAT('Vpar/V$')
	CALL AGTCHS(TEXT1)
 
c--add in legend to identify lines:
	call AGTmhs(910,670,'Energies$')
	call AGTmhs(910,645,'(KeV)$')
	iy=645
	do 550 i=1,5
	iy=iy-25
	write(string,510)enerev(iengs(i))/1000.
510	format(f8.3,'$')
550	call AGTmhs(910,iy,string)
 
	CALL UPAUSE(0)
      RETURN
      END
