C
C     THIS PROGRAM PLOTS THE RESULTS of F AT 5 PITCH ANGLES
C     AS A FUNCTION OF ENERGY
C
      SUBROUTINE PLOTE
C
C
C     COMMON BLOCKS
C
	include 'FPPCOM'
 
	character string*80
	DIMENSION FPLO(0:maxen)
C
C     FIND MAXIMUM DATUM TO BE PLOTTED
C
      SMAX=0.0
      DO 300 I=0,maxen
      DO 300 J=1,5
      IANG=NiAngls(J)
      IF(SMAX.LT. f1(I,IANG) ) SMAX=f1(I,IANG)
  300 CONTINUE
C
C     PLOT AT 5 ANGLES, NORMALIZED TO MAXIMUM
C
	call initt(24)
	CALL BINITT
	call fpgrlab
	call npts(maxen+1)
      DO 100 J=1,5
      IANG=NiAngls(J)
      DO 200 I=0,maxen
      FPLO(I)=f1(I,IANG)/SMAX
  200 CONTINUE
c--plot limits can be changed by debugger if desired:
	data zfemin/.001/
	data zfemax/1.00/
	data xmin/0.0/
	data xmax/0.0/
	if(xmax .eq. 0.0)xmax=enerev(maxen)
      IF(J.EQ.1) CALL DLIMY(zfemin,zfemax)
	if(j .eq. 1)call dlimx(xmin,xmax)
      IF(J.EQ.1) CALL YTYPE(2)
      IF(J.EQ.1) CALL CHECK(enerev,FPLO)
      IF(J.EQ.2) CALL LINE(7474)
      IF(J.EQ.3) CALL LINE(5454)
      IF(J.EQ.4) CALL LINE(3434)
      IF(J.EQ.5) CALL LINE(1414)
      IF(J.EQ.1) CALL DSPLAY(enerev,FPLO)
      IF(J.NE.1) CALL CPLOT(enerev,FPLO)
  100 CONTINUE

c For comparison, also plot a numerical Maxwellian:
      do i=0,maxen
         fplo(i)=fmxwel(i)/fmxwel(1)
      enddo
      call check(enerev,fplo)
      call line(1212)
      call cplot(enerev,fplo)

c label plot and axes:
      TIMM=TIME*1000.
	WRITE(TEXT1,10)
10	FORMAT('Fast ion f(E) for several pitch angle''s Vpar/V$')
	CALL AGTCGT(750,TEXT1)
	WRITE(TEXT1,20) TIMM,NSHE,smax
20      FORMAT('Time = ',F5.1,' MSEC','  radial shell # =',I2,
     >         '  max plotted f =',1pe10.3,'$')
	CALL AGTCGT(0,TEXT1)
	WRITE(TEXT1,30)
30	FORMAT('Energy (eV)$')
	CALL AGTCHS(TEXT1)
 
c--add in legend to identify curves:
	call AGTmhs(910,670,'Vpar/V''s$')
	iy=670
	do 45 j=1,5
	iy=iy-25
	write(string,43)xsi(NiAngls(j))
43	format(f6.3,'$')
45	call AGTmhs(910,iy,string)
        call agtmhs(910,iy-25,'f_Maxwell$')

	CALL UPAUSE(0)
      RETURN
      END
