C
C     THIS PROGRAM PLOTS THE FUSION NEUTRON PRODUCTION
C     DUE TO BEAM-TARGET REACTIONS AS A FUNCTION OF TIME
C
      SUBROUTINE PLOTFU
C
C
C     COMMON BLOCKS
C
	include 'FPPCOM'
 
	character text*80
 
	call initt(240) !switch to graphics and clear screen
	CALL BINITT
	call fpgrlab
 
	CALL NPTS(loomax+1)
	call dlimx(0.,timmy(loomax))
 
!allow user to set log (default) or linear y scale for neutrons:
	CALL YTYPE(LYtypFus)
 
	zfumax=0.0
	zfumin=fppinf
	do 500 ireact=1,6
	do 500 itime=0,loomax
	zfumax=max(zfumax,fpfustot(itime,ireact))
	if(fpfustot(itime,ireact) .ne. 0.0)
	1   zfumin=min(zfumin,fpfustot(itime,ireact))
500	continue
	zfumin=max(zfumin,zfumax/1.e6)
	call dlimy(zfumin,zfumax)
 
	call symbl(ichar('T'))
	CALL CHECK(timmy,fpfustot(0,1))
	CALL DSPLAY(timmy,fpfustot(0,1))
	call symbl(ichar('3'))
	call cplot(timmy,fpfustot(0,2))
	call symbl(ichar('D'))
	call cplot(timmy,fpfustot(0,4))
 
	if(fufiti .eq. 1.0) then
	write(text,555)zfumax
555	format('Max=',1pe8.2,'       (D+D includes finite Ti)$')
	else
	write(text,556)zfumax
556	format('Max=',1pe8.2,'       (beam + zero Ti target)$')
	endif
 
	call frame
	call AGTcgt(0,text)
	call AGTcgt(735,futitl)
	call AGTcgt(760,
	1 'Neutrons and protons per second from beam-target reactions$')
	CALL AGTCVS('per sec$')
	CALL AGTCHS('time (sec)$')
 
	CALL UPAUSE(0)
 
c type out the fusion reaction profiles:
 
c	call finitt(0,780)
c	write(lsysout,*) 'fusion reaction rate profiles (/cm**3/sec):'
c	write(lsysout,*) 'D-T:'
c	write(lsysout,*) (fpfuspro(i,1),i=1,nshell)
c	write(lsysout,*) 'D-He3:'
c	write(lsysout,*) (fpfuspro(i,2),i=1,nshell)
c	write(lsysout,*) 'D-D:'
c	write(lsysout,*) (fpfuspro(i,4),i=1,nshell)
 
c	write(lsysout,*) 'type a character to continue...'
c	call upause(0)
 
c plot fusion reaction profiles:
 
	call initt(240)
	call binitt
	call fpgrlab
 
	call npts(nshell)
c	call slimx(125,475)
c	call slimy(125,700)
	call dlimx(0.,1.0)
	zymin=fppinf
	zymax=-fppinf
	call mnmx(fpfuspro(1,1),zymin,zymax)
	call mnmx(fpfuspro(1,2),zymin,zymax)
	call mnmx(fpfuspro(1,4),zymin,zymax)
	call dlimy(0.0,zymax)
 
	call symbl(ichar('T'))
	CALL CHECK(rovera,fpfuspro(1,1))
	CALL DSPLAY(rovera,fpfuspro(1,1))
	call symbl(ichar('3'))
	call cplot(rovera,fpfuspro(1,2))
	call symbl(ichar('D'))
	call cplot(rovera,fpfuspro(1,4))
 
	if(fufiti .eq. 1.0) then
	write(text,2555)zymax
2555	format('Max=',1pe8.2,'       (D+D includes finite Ti)$')
	else
	write(text,2556)zymax
2556	format('Max=',1pe8.2,'       (beam + zero Ti target)$')
	endif
 
	call frame
	call AGTcgt(0,text)
	call AGTcgt(735,futitl)
	call AGTcgt(760,
	1 'Neutrons & protons /cm**3/sec from beam-target reactions$')
	CALL AGTCVS('/cm**3/sec$')
	CALL AGTCHS('r/a$')
 
	call upause(0)
 
	RETURN
	END
