c
C     THIS PROGRAM PLOTS THE FLUX OF FAST NEUTRALS AT NLINE
C     SIGHTLINES AS A FUNCTION OF ENERGY
c MODIFIED TO INLCUDE A SWITCH BETWEEN LINEAR AND LOG
c PLOTS (Don Roberts - August 17, 1988).
C
C	IT ALSO PLOTS THE FLUX OF FAST NEUTRALS AT NLINE
C	SIGHTLINES AS A FUNCTION OF TIME  (R.J.G. MAY 19, 1982)
C
      SUBROUTINE PLOTSS
C
C
C     COMMON BLOCKS
C
	include 'FPPCOM'
 
	character string*80
 
	PARAMETER (IMFPLO=MAXEN+MXSLIN+MAXTIM+1)
	real fplo(imfplo)  !temp storage for plots
	real tmplo(0:maxtim) !time axis for plots
 
! function to index into SPECTR(ien,jsightline,ntime):
! (ntime=0,1,...,loomax/snkip)
	indspe(i,j,n)=1+(i-1+nencx*(j-1+nline*n))
 
c (variables now initialized by fppblk2.for):
c! plotting controls:
c	data LlnFpl/0/	!=0 for old size with 10**n scale
c			!=1 for new size with ln(f) scale
c			!=2 for linear f scale
c	data fmin/25.0/	!min ln(f)
c	data fmax/40.0/	!max ln(f)
c	data emax/0.0/	!max energy (ev) (=0 for default)
c	data ymin/.001/	!ymin for 10**n scale plots
c	data ymax/1./	!ymax for 10**n scale plots
c	data LcxRtp/1/	!plot cx flux vs Rtan
c	data Rtmin/0.0/	!Rtan min
c	data Rtmax/132./!Rtan max
c	DATA LPrintF/0/ ! 1= printout CX spectra
 
! define list of times at which CX spectra where calculated:
	do 111 itt=0,loomax/nSkipCX
	tmplo(itt)=Timmy(itt*nSkipCX)
111	CONTINUE
 
c
C	LOOP OVER TIME VALUES
C	GET NPLTE SPECTRA VS ENERGY
C
	if(nplte .eq. 0)go to 1001
	NSKE=(LOOMAX/nSkipCX+1)/NPLTE
	if(nske .lt. 1)nske=1
	DO 1000 ITT=0,LOOMAX/nSkipCX
	IF (MOD(ITT+1,NSKE).NE.0) GOTO 1000
C
C     FIND MAXIMUM DATUM TO BE PLOTTED
C
	SMAX=0.0
	DO 300 I=1,nencx
	DO 300 J=1,NLINE
	IF(SMAX.LT.spectr(indspe(i,j,itt)))
	1	 SMAX=SPECTR(indspe(i,j,itt))
300	continue
C
C     PLOT AT NLINE SIGHTLINES, NORMALIZED TO MAXIMUM
C
	call initt(0)
	CALL BINITT
	call erase
	call fpgrlab
 
	if(LlnFpl .eq. 1)then
c		!adjustable for precise overlays of plots:
c		data NYminCX/100/
c		data NYmaxCX/700/
c		data NXminCX/500/
c		data NXmaxCX/1000/
		call slimy(NYminCX,NYmaxCX)
		call slimx(NXminCX,NXmaxCX)
		call dlimy(fmin,fmax)
	else
		call slimy(130,690)
		call dlimy(ymin,ymax)
		call ytype(2)
	endif
	call yneat(0)
	if(emax .ne. 0.0)then
		call dlimx(0,emax)
		call xneat(0)
	else
		call dlimx(0,ener(nencx))
	endif
 
	do 100 j=1,nline
 
	if(LlnFpl .eq. 0)then
	do 200 I=1,nencx
	fplo(i)=spectr(indspe(i,j,itt))
	if(smax .ne. 0.0) fplo(i)=fplo(i)/smax
200	continue
	else
	do 210 i=1,nencx
	fplo(i)=-100
210	if(spectr(indspe(i,j,itt)) .gt. 0.0)
	1	fplo(i)=alog(spectr(indspe(i,j,itt))*1.0e15)
	endif
 
C
C	RENORMALIZE SMAX TO ACCOUNT FOR 1.0E15 FUDGE IN SPECT.FOR
C	THE RESULTING DISTRIBUTION FUNCTION IS IN
C	THE STANDARD UNITS FOR C-X SPECTRUM AS DESCRIBED IN
C	DAVIS AND MUELLER'S PDX ANALYZER PAPER
C	(SPECIFICALLY THE ANGULAR FACTOR IS  [/(D OMEGA/4*PI)]
C	**NOT** PER STERADIAN
C
!
!  Conversion to Davis, Mueller, Keane conventions is now done
!  in detech, here we just need to adjust the 10**15 factor
!  from spect:
	if(j .eq. 1) srnmax=smax*1.e15
 
	call npts(nencx)
      IF(J.EQ.2) CALL LINE(7474)
      IF(J.EQ.3) CALL LINE(5454)
      IF(J.EQ.4) CALL LINE(3434)
      IF(J.EQ.5) CALL LINE(1414)
	call check(ener,fplo)
	if(j .eq. 1)call dsplay(ener,fplo)
	if(j .gt. 1)call cplot(ener,fplo)
100	continue
 
	TIMM=Timmy(nSkipCX*ITT)*1000.
	CALL AGTCGT(770,'Fast Neutral Spectrum$')
	if(LlnFpl .ne. 0)then
	WRITE(TEXT1,20) TIMM, NSHE-1
20	FORMAT('T = ',F5.1,1X,'MSEC',5X,I2,' SHELLS$')
	else
	WRITE(TEXT1,40) TIMM, NSHE-1, SRNMAX
40	FORMAT('T = ',F5.1,1X,'msec',5X,I2,
	1   ' shells   Max f= ',1pE8.2,'$')
	endif
	CALL AGTCGT(0,TEXT1)
	call agtcgt(50,'Energy (eV)$')
 
c--add in legend to identify curves:
	ixpos=910
	call AGTmhs(ixpos,670,'Rtans:$')
	iy=670
	do 45 j=1,nline
	iy=iy-25
	write(string,43)tans(j)
43	format(f5.0,'$')
45	call AGTmhs(ixpos,iy,string)
 
	CALL UPAUSE(0)
	call finitt(0,0)
1000	CONTINUE
C
C	LOOP OVER ENERGY VALUES
C	GET NPLTT SPECTRA VS. TIME
C
1001	if(npltt .le. 0)go to 2600
	if(npltt .gt. nencx) npltt=nencx
	DO 2500 I=1, NPLTT
	iesp=i*float(nencx)/float(npltt)
C
C	FIND MAXIMUM DATUM TO BE PLOTTED
C
	SMAX=0.0
	DO 2300 ITT=0, LOOMAX/nSkipCX
	DO 2300 J=1,NLINE
	IF(SMAX.LT.SPECTR(indspe(iesp,j,itt)))
	1	 SMAX=SPECTR(indspe(iesp,j,itt))
2300	CONTINUE
C
C	PLOT AT NLINE SIGHTLINES, NORMALIZED TO THE MAXIMUM
C
	call initt(0)
	CALL BINITT
	call erase
	call fpgrlab
 
	DO 2100 J=1,NLINE
	DO 2200 ITT=0,LOOMAX/nSkipCX
	FPLO(ITT+1)=SPECTR(indspe(iesp,j,itt))
	if(smax .ne. 0.0) fplo(itt+1)=fplo(itt+1)/SMAX
2200	CONTINUE
C
C
C	RENORMALIZE SMAX -- SEE ABOVE
C
	if(j .eq. 1) srnmax=smax*1.e15
C
	IF(J.EQ.1) CALL SLIMY(130,690)
	IF(J.EQ.1) CALL DLIMY(0.0011,0.99)
	if(j .eq. 1) call dlimx(tmplo(0),tmplo(loomax/nSkipCX))
C	IF(J.EQ.1) CALL YTYPE(2)
	IF(J.EQ.1) CALL NPTS(LOOMAX/nSkipCX+1)
	IF(J.EQ.1) CALL CHECK(TMPLO,FPLO)
	IF(J.EQ.2) CALL LINE(7474)
	IF(J.EQ.3) CALL LINE(5454)
	IF(J.EQ.4) CALL LINE(3434)
	IF(J.EQ.5) CALL LINE(1414)
	IF(J.EQ.1) CALL DSPLAY(TMPLO,FPLO)
	IF(J.NE.1) CALL CPLOT(TMPLO,FPLO)
2100	CONTINUE
C
	CALL AGTCGT(750,'Fast Neutral Spectrum versus time$')
	WRITE(TEXT1,22) ENER(IESP), nshe-1,srnmax
22	FORMAT('E = ',1PE8.2,1X,'eV',5X,I2,
	1   ' shells   Max f= ',1pe8.2,'$')
	CALL AGTCGT(0,TEXT1)
	CALL AGTCHS('Time (s)$')
 
c--add in legend to identify curves:
	call AGTmhs(910,670,'Rtans:$')
	iy=670
	do 2145 j=1,nline
	iy=iy-25
	write(string,2143)tans(j)
2143	format(f5.0,'$')
2145	call AGTmhs(910,iy,string)
 
	CALL UPAUSE(0)
	call finitt(0,0)
2500	CONTINUE
 
!*************************************************
! plot CX flux vs. Rtan at the final time step:
!*************************************************
2600	if(LcxRtp .le. 0)go to 4000
	itt=loomax/nSkipCX
!find max value:
	smax=0.0
	do 3010 i=1,nencx
	do 3010 j=1,nline
3010	if(smax .lt. spectr(indspe(i,j,itt)))
	1	smax=spectr(indspe(i,j,itt))
 
	call initt(0)
	call binitt
	call erase
	call fpgrlab
 
	if(LlnFpl .eq. 1) then
		!adjustable for precise overlays of plots:
		call slimy(NYminCX,NYmaxCX)
		call slimx(NXminCX,NXmaxCX)
	    if(Lcxrtp .eq. 1) then
		call dlimy(fmin,fmax)
	    else
		if(fcxlmax .gt. 0.0) call dlimy(0.0,fcxlmax)
		if(fcxlmax .eq. 0.0) call dlimy(0.0,smax*1.e15)
	    endif
	else
		call slimy(130,690)
		call dlimy(ymin,ymax)
		call ytype(2)
	endif
	call yneat(0)
	call dlimx(Rtmin,Rtmax)
	call npts(nline)
 
	do 3100 i=nencx,1,-1
 
	zsmax=smax
	if(Lcxrtp .eq. 2) zsmax=1.e-15 ! put f in Davis-Mueller-Keane units
 
	if(LlnFpl .eq. 0 .or. Lcxrtp .eq. 2)then
	do 3020 j=1,nline
	fplo(j)=spectr(indspe(i,j,itt))
3020	if(zsmax .ne. 0.0)fplo(j)=fplo(j)/zsmax
	else
	do 3021 j=1,nline
	fplo(j)=-100
3021	if(spectr(indspe(i,j,itt)) .gt. 0.0)
	1	fplo(j)=alog(spectr(indspe(i,j,itt))*1.0e15)
	endif
 
	if(i .eq. nencx-1)call line(7474)
	if(i .eq. nencx-2)call line(5454)
	if(i .eq. nencx-3)call line(3434)
	if(i .eq. nencx-4)call line(1414)
	call check(Tans,fplo)
	if(i .eq. nencx)call dsplay(Tans,fplo)
3100	if(i .ne. nencx)call cplot(Tans,fplo)
 
	call AGTcgt(750,'Fast Neutral Spectrum Vs. Rtan $')
	call AGTcgt(30,'Rtan (cm)$')
	timm=Timmy(nSkipCX*itt)*1000.
	WRITE(string,3140) TIMM, NSHE-1, smax*1.0e15
3140	FORMAT('t = ',F5.1,1X,'msec',5X,I2,
	1   ' shells   Max f= ',1pe8.2,'$')
	call AGTcgt(0,string)
 
!add in legend to identify curves:
	call AGTmhs(910,700,'Energies$')
	call AGTmhs(910,675,' (KeV)   $')
	iy=670
	do 3145 i=nencx,1,-1
	iy=iy-25
	write(string,3143)ener(i)/1000.
3143	format(f6.1,'$')
3145	call AGTmhs(910,iy,string)
 
	call upause(0)
	call finitt(0,0)
C
4000	IF (LPrintF.NE.1) GOTO 9876
C
C	WRITE OUTPUT FILE TO DISK
C
        WRITE(46,2030)
2030    FORMAT('1',///,20X,'FAST NEUTRAL SPECTRUM')
	DO 2000 I=1,nencx
	WRITE(46,2010) ENER(I)
2010	FORMAT(//' ENERGY =',F10.0,/)
	WRITE(46,2015) (TANS(ILIN),ILIN=1,NLINE)
2015	FORMAT('                ',5F12.1/)
	DO 2000 ITT=0,LOOMAX/nSkipCX
	TIMM=Timmy(itt*nSkipCX)*1000.
!	WRITE(46,2020) TIMM,(5.0E16*SPECTR(indspe(i,j,itt)),J=1,NLINE)
	write(46,2020) timm,(1.0e15*spectr(indspe(i,j,itt)),j=1,nline)
2020    FORMAT(F5.1,' MSEC      ',5E12.5)
2000	CONTINUE
9876	RETURN
      END
