      subroutine setup
      include 'SPRINC'
      real rmaj(nchi,npsi),zed(nchi,npsi),hpsi(nchi,npsi),
     %     hchi(nchi,npsi),psi(npsi),chi(nchi),pquad(npsi),pcoef(nchi),
     %     difpsi(npsi,npsi),difchi(nchi,nchi),
     %     ddfpsi(npsi,npsi),ddfchi(nchi,nchi),
     %     origin(nchi),rayrz(2),drayrz(2),d02wrk(2,7),
     %     radius(nvvgrid),drdth(nvvgrid),theta(nvvgrid)
      complex cwork1(nchi,npsi),cwork2(nchi,npsi),
     %        cwork3(nchi,npsi),cwork4(nchi,npsi)
      common /metric/ rmaj,zed,hpsi,hchi,psi,chi,pquad,pcoef
     %       /vessel/ rmajor,rminor,radius,drdth,theta
     %       /difmtx/ difpsi,difchi,ddfpsi,ddfchi
     %       /cwork/ cwork1,cwork2,cwork3,cwork4
     %       /ray/ ichirz,origin
      external dray
      logical iconv
c
c     SETUP produces the collocation grid, the metric coefficients
c     for the orthogonal coordinate system, and the pseudospectral
c     derivative matrices, i.e., the contents of the /metric/ and
c     /difmtx/ blocks.  (NAG routine D02BAE produces the grid by
c     initial-value integration along the constant-chi rays.  The
c     /vessel/ block must be filled prior to calling SETUP.)
c
      data nrefin,tol /10,1.e-6/
      pi=abs(acos(-1.0))
      npsim1=npsi-1
c
c     Produce chi vector and derivative matrices
      dchis=2.*pi/float(nchi)
      do 15 i=1,nchi
   15 chi(i)=float(i-1)*dchis
      difchi(1,1)=0.
      ddfchi(1,1)=-float((nchi-1)*(nchi-2))/12.
      signk=-1.
      do 17 k=2,nchi
      signk=-signk
c careful: tan(pi/2)->infinity, so use cos and sin instead:
      difchi(1,k)=signk*.5*cos(.5*chi(k))/sin(.5*chi(k))
   17 ddfchi(1,k)=signk*(.5/sin(.5*chi(k))**2-.25*float(nchi))
      do 16 i=2,nchi
      do 16 k=1,nchi
      if (i.le.k) then
      idiff=k+1-i
      else
      idiff=k+1-i+nchi
      endif
      difchi(i,k)=difchi(1,idiff)
   16 ddfchi(i,k)=ddfchi(1,idiff)
c
c     Produce psi vector and derivative matrices
      dtp=pi/float(npsim1)
      signk=(-1.)**(1+npsi-2*(npsi/2))
      difpsi(1,1)=-(2.*float(npsim1)**2+1.)/3.
      difpsi(npsi,npsi)=(2.*float(npsim1)**2+1.)/3.
      difpsi(1,npsi)=-signk
      difpsi(npsi,1)=signk
      ddfpsi(1,1)=4.*(float(npsim1)**4-1.)/15.
      ddfpsi(npsi,npsi)=4.*(float(npsim1)**4-1.)/15.
      ddfpsi(1,npsi)=-4.*(float(npsim1)**2-1.)*difpsi(1,npsi)/3.
      ddfpsi(npsi,1)=4.*(float(npsim1)**2-1.)*difpsi(npsi,1)/3.
      psi(1)=0.
      psi(npsi)=1.
      signj=1.
      do 5 j=2,npsim1
      signj=-signj
      xj=cos(float(j-1)*dtp)
      difpsi(j,j)=xj/(1.-xj**2)
      difpsi(1,j)=-4.*signj/(1.-xj)
      difpsi(npsi,j)=4.*signj*signk/(1.+xj)
      difpsi(j,1)=-signj/(xj-1.)
      difpsi(j,npsi)=-signj*signk/(xj+1.)
      ddfpsi(j,j)=-4.*(float(npsim1)**2+2.)/(3.*(1.-xj**2))
     %            -4.*xj**2/(1.-xj**2)**2
      ddfpsi(1,j)=(4./(1.-xj)-(4.*float(npsim1)**2+2.)/3.)*
     %                                                 difpsi(1,j)
      ddfpsi(npsi,j)=(-4./(1.+xj)+(4.*float(npsim1)**2+2.)/3.)*
     %                                                 difpsi(npsi,j)
      ddfpsi(j,1)=-2.*((2.+xj)/(1.-xj**2))*difpsi(j,1)
      ddfpsi(j,npsi)=2.*((2.-xj)/(1.-xj**2))*difpsi(j,npsi)
    5 psi(j)=.5-.5*xj
      signj=-1.
      do 6 j=3,npsim1
      signj=-signj
      signk=1.
      do 6 k=2,j-1
      signk=-signk
      difpsi(j,k)=signj*signk/(psi(j)-psi(k))
      difpsi(k,j)=signj*signk/(psi(k)-psi(j))
      ddfpsi(j,k)=(2./(psi(k)-psi(j))-(psi(j)-.5)/(psi(j)*(1.-psi(j))))*
     %                                                       difpsi(j,k)
    6 ddfpsi(k,j)=(2./(psi(j)-psi(k))-(psi(k)-.5)/(psi(k)*(1.-psi(k))))*
     %                                                       difpsi(k,j)
c
c     Produce psi quadrature weights;
c     as Npsi -> infinity, Pquad(Psi) -> sqrt(Psi*(1.-Psi))
      do 7 i=1,npsi
    7 pquad(i)=0.
      istart=-2*((npsi-2)/2)
      istop=2*((npsi-1)/2)
      do 8 j=istart,istop,2
      t=float(j)*dtp
      xwork=1./(1.-float(j**2))/float(npsim1)
      do 8 i=1,npsi
    8 pquad(i)=pquad(i)+xwork*cos(t*float(i-1))
c
c     Produce 2D grid with refinement iteration on the initial
c     chi-ray directions, and calculate hpsi using the formula:
c        hpsi**2=1./([dpsi/drmaj]**2+[dpsi/dzed]**2)
      iinit=0
      do 25 irefin=1,nrefin
 
      call chiorg(iinit,thconv,iconv)
c      write(6,*)' relative convergence of outer theta grid =',
c     %            thconv
      if(iconv .eq. .true.) goto 27
 
      do 20 i=1,nchi
      ichirz=i
      rmaj(i,1)=rmajor
      zed(i,1)=0.
      psiray=0.
      rayrz(1)=0.
      rayrz(2)=0.
      call dray(0.0,rayrz,drayrz)
      hpsi(i,1)=sqrt(drayrz(1)**2+drayrz(2)**2)
 
      do 20 j=2,npsi
      psiend=psi(j)
 
      if (i.le.nchi/2+1) then
      toler=tol
      nequtn=2
      ifail=0
      call d02bae(psiray,psiend,nequtn,rayrz,toler,dray,d02wrk,ifail)
      rmaj(i,j)=rayrz(1)+rmajor
      zed(i,j)=rayrz(2)
      call dray(psiend,rayrz,drayrz)
      hpsi(i,j)=sqrt(drayrz(1)**2+drayrz(2)**2)
 
      else
      rmaj(i,j)=rmaj(nchi-i+2,j)
      zed(i,j)=-zed(nchi-i+2,j)
      hpsi(i,j)=hpsi(nchi-i+2,j)
      endif
 
20    continue
 
c      call sprout(-1) ! plot the grid to check the convergence
25    continue
 
      write(6,*)'Fatal error in subroutine SETUP'
      write(6,*)' relative convergence of outer theta grid =',
     %            thconv
      write(6,*)
     %	   'Failure to converge in laying out the orthogonal grid'
      write(6,*)' in',nrefin,' iterations'
      call aborter(6,'Fatal error in SPRUCE''s SETUP subroutine')
 
27    continue
 
c      write(6,*)'SETUP:  Wave code orthogonal grid converged after',
c     %	  irefin-1,' iterations.'
c      write(6,*)
c     %	  ' relative convergence of outer theta grid =',thconv
 
c
c     Calculate hchi and pcoef using the formulas:
c          hchi**2=[drmaj/dchi]**2+[dzed/dchi]**2
c          pcoef=lim(psi->0)[psi*hpsi/hchi]=1./[dorigin/dchi]
      do 30 i=1,nchi
      do 30 j=1,npsi
   30 cwork1(i,j)=cmplx(rmaj(i,j),zed(i,j))
      call dchi(cwork1,cwork2)
      do 40 i=1,nchi
      do 40 j=1,npsi
   40 hchi(i,j)=abs(cwork2(i,j))
      do 48 i=1,nchi
      pcoef(i)=1.
      do 47 j=1,nchi
   47 pcoef(i)=pcoef(i)+difchi(i,j)*(origin(j)-chi(j))
   48 pcoef(i)=1./pcoef(i)
c
c     smooth
      do 50 i=1,nchi
      cwork3(i,1)=cmplx(hpsi(i,1),pcoef(i))
      do 50 j=2,npsi
   50 cwork3(i,j)=cmplx(hpsi(i,j),psi(j)*hpsi(i,j)/hchi(i,j))
      call SPRFIL(cwork3,0)
      do 51 i=1,nchi
      pcoef(i)=imag(cwork3(i,1))
      do 51 j=1,npsi
      hpsi(i,j)=real(cwork3(i,j))
   51 hchi(i,j)=psi(j)*hpsi(i,j)/imag(cwork3(i,j))
c
      call sprout(-1)
      return
      end
