C
      SUBROUTINE SPECT
C
C     THIS PROGRAM ACCUMULATES THE OBSERVED FAST NEUTRAL
C     SPECTRUM IN THE ARRAY SPECTR, AS THE DISTRIBUTION
C     FUNCTION IS CALCULATED SHELL BY SHELL
C
c--it includes a background maxwellian contribution to the
c       cx spectrum.  The density of the background maxwellian
c       is bkgmax * dhy *electron density, so it can be turned off
c       by setting bkgmax=0.0 in the fpp input data file.
C     SET UP COMMON BLOCKS
C
	include 'FPPCOM'
	logical lfeqtite
 
!index funtion into SENS(ien,jsightline,kshell,Langle) :
	IND(I,J,K,L)=(I-1+nencx*(J-1+NLINE*(K-1+NSHELL*(L-1))))+1
 
!index function into SPECTR(ien,jsightline,ntime): (ntime=0,1,2,...)
	indspe(i,j,n)=1+(i-1+nencx*(j-1+nline*n))
 
!type warning if a background is used:
	if(bkgmax .ne. 0.0 .and.
	1   (aplasz(2) .ne. rZbeam .or. aplasamu(2) .ne. Ab))then
	write(lsysout,*)
     1  ' It is not clear to me that subroutine SPECT is'
	write(lsysout,*) ' correct in the way it includes background'
	write(lsysout,*)
     1  ' contributions to the CX spectra for a non-mass-'
	write(lsysout,*) ' resolving analyzer if the beam'		
	write(lsysout,*)
     1  ' and bulk ion species are different.--greg hammett'
	write(lsysout,*)
     1  ' ****************************************************'
	stop
	end if
 
C
C     ACCUMULATE
C
	VT3=(1.384E6*SQRT(TIPRO(NSHE)))**3
	FCONST=5.9826E16/VT3
	fcons2=0.0
c--loop over energy:
	do 100 ien=1,nencx
	ener(ien)=enerev(NFENCX+ien-1)
 
c--calculate background contribution to f:
c including depletion of main plasma ions by impurities:
	dhy=(rZimp-rZeff)/(rZimp-aplasz(2))/aplasz(2)
 
	if(bkgmax .ne. 0.0)then
c
c default is to use an f(E) which is in collisional equilibrium with
c both electrons and ions, so that the slope of f(E) is Ti at moderate
c energies, and is Te at high energies:
c
	    data lfeqTiTe /.true./
	    if(.not. lfeqTiTe) then
		fcons2=fconst*bkgmax*dhy*denpro(nshe)
	1	*1.0e13*exp(-ener(ien)/tipro(nshe))
	    else
		fcons2=feqTiTe(NFENCX+ien-1)
	    endif
	endif
 
c--loop over sight lines
      DO 100 ILIN=1,NLINE
c--loop over pitch angles
      DO 100 IAN=1,maxxsi/2
      IAP=IAN
      IF(SIGN(1.0,TANS(ILIN)).GT.0.0) IAP=IAN+maxxsi/2
 
! force f to be > 0.  (this is necessary so that the total
! cx spectrum is the sum of the spectra from each shell)
	fbeam=f1(ien+NFENCX-1,iap)
	if(fbeam .lt. 0.0)fbeam=0.0
 
c--signal = f(fpp) * "sensitivity"
c--see comments in sccf for normalization of f(fpp).
c--gwh:it is not clear to me that this is correct when the beam
c       species and the background species are different.  SENS
c       is different for hydrogen and deuterium particles of the
c       same energy because the cx cross section is different and
c       signal attenuation is different.
	spectr(indspe(ien,ilin,niTime/nSkipCX)) =
	1       spectr(indspe(ien,ilin,niTime/nSkipCX))+
	1       (fbeam+fcons2)
	1       *Sens(ind(ien,ilin,nshe,ian))*1.E-15
!The 10**-15 fudge is corrected for in PLOTSS
 
100     continue
	return
	end
