	complex function zfunavg(s,deltas)
c
c evaluates the average ZFUN(s) for real s, from s-deltas to s+deltas,
c where ZFUN is the plasma dispersion function of Fried and Conte.
c
	real s
	complex zfuntmp
	data piroot /1.7724538509055/
	data sqrt2  /1.414213562373095/
	ifail=1
 
	s1=s-deltas
	s2=s+deltas
	if( (s1 .gt. 2.  .and. s2 .gt.  2.) .or.
	1   (s1 .lt. -2. .and. s2 .lt. -2.) .or.
	1   (deltas .lt. 0.2)) then
 
c just use the local Zfunction:
 
	zreal=-2.*s15afe(s,ifail)   !@vax
c@	zreal=-2.*s15aff(s,ifail)   ! cray
	zimag=0.
	if (abs(s).lt.5.) zimag=piroot*exp(-s**2)
	zfunavg=cmplx(zreal,zimag)
 
	else
 
c use an approximate average of the Z-function around the
c neighborhood of this point:
 
	zfuntmp=0.0
	imax=2*deltas/.2
	do 20 i=1,imax
	zs=s1+(s2-s1)*(i-0.5)/imax
 
	zreal=-2.*s15afe(zs,ifail)   !@vax
c@	zreal=-2.*s15aff(zs,ifail)   ! cray
	zimag=0.
	if (abs(zs).lt.5.) zimag=piroot*exp(-zs**2)
20	zfuntmp=zfuntmp+cmplx(zreal,zimag)
	zfunavg=zfuntmp/imax
 
	endif
 
	return
	end
